/* CGIparse.c - */

/*---------------------------------------------------------------------
Module: CGIparse.c
Date: 2 March 1996
Author: Fernando J. Echevarrieta Fernandez (echeva@dit.upm.es)
Version: 1.0
Description: Parser & URL decoder
---------------------------------------------------------------------*/

#include <string.h> /* strcpy, strsep */
#include <stdio.h>  /* fopen, fgets */
#include <stdlib.h> /* malloc */

#include "CGIparse.h"

#define MAXLEN 256  /* Max. length expected for a line in a HTML page */

static struct pair *insert(struct pair *node, char *var_value, char *var_name);
static struct pair *pair_alloc();

/* ---------------------------------------------------------------- */

int CGIparser(char *string, struct pair **p) 
/* Extracts pairs {name=value} from string and return them in list p */
{
        char *token;
        char *name, *value;
        char *auxp1, *auxp2;
        char hex_code[3];
        int  code;

        hex_code[3]='\0';

        while ((token=strsep(&string,"&")) != NULL) {
              name  = strsep(&token,"=");
              auxp1 = strsep(&token,"=");
              value = auxp2 = strdup(auxp1);

              while( *auxp1 != '\0') {
                switch (*auxp1) {
                  case '+' : *auxp2++ = ' '; 
                             *auxp1++; 
                             break;
                  case '%' : *auxp1++;
                             hex_code[0] = *auxp1++; 
                             hex_code[1] = *auxp1++;
                             code=strtol(hex_code,(char **)NULL,16);
                             *auxp2++ = code;
                             break;
                  default  : *auxp2++ = *auxp1++;
                             break;
                } 
              }
              *auxp2 = '\0';

              *p=insert(*p,value,name);
        }

} /* end CGIparser */

/* ---------------------------------------------------------------- */

struct pair *insert(struct pair *node, char *var_value, char *var_name)
{
        if ( node == NULL )
        {
                node = pair_alloc(var_name,var_value);
                node->next = NULL;
                strcpy(node->name, var_name );
                strcpy(node->value,var_value);
        }
        else
                node->next = insert(node->next, var_value, var_name);
        return node;

} /* end insert */

/* ------------------------------------------------------------------*/

int list_process(struct pair *node, int (*function)(char *name, char *value))
/* Process each node in the list with the function indicated */
{
        (*function)(node->name,node->value);
        if ( node->next != NULL )
        {
           list_process(node->next,function);
        }

} /* end list_process */

/* ------------------------------------------------------------------*/

struct pair *pair_alloc(char *name, char *value)
{
	struct pair *p;

        p = (struct pair *)malloc(sizeof(struct pair));
	p->name  = (char *)malloc(strlen(name) +1); 
	p->value = (char *)malloc(strlen(value)+1); 

	return p;

} /* end pair_alloc */

/* ------------------------------------------------------------------*/
